
'Program: 20m2-RAT-RF-RX-bas
'IDE: PICAXE Programming editor 5.5.5
'Target IC: 20m2
'Description: This program receives data from a transmitter, and displays it on an LCD

#picaxe 20m2
#terminal off

symbol RXPin	= c.6   'RF modules datapin is connected here
symbol BAUD		= N2400 'Baud rate to use
symbol trap		= b10	  'Variable to hold the received trap number if you have multiple traps
symbol temptrap	= b11   'Variable to store temporary value

EEPROM 0, ("RAT TRAP MONITOR")	'EEPROM 0-15
EEPROM 16,("   RAT CAUGHT   ")	'EEPROM 16-31
EEPROM 32,("TRAP:           ")	'EEPROM 32-47

init:
	let pinsb = 0	'Clear all output lines
	let b3 = 0		'Reset variable b3
	let dirsb = 252 	'Set pinsb 2-7 as output lines
	pause 500 		'Wait 500 ms for LCD to reset
	let pinsb = 48 	'Set to 8-bit operation 
	pulsout b.3,1	'Send data by pulsing "enable"
	pause 10		'Wait 10 ms
	pulsout b.3,1	'Send data again
	pulsout b.3,1	'Send data again
	let pinsb = 32	'Set to 4-bit operation
	pulsout b.3,1	'Send data
	pulsout b.3,1	'Send data again
	let pinsb = 128	'Set to two line operation
	pulsout b.3,1	'Send data
	let b1 = 14		'Screen on, cursor on instruction
	gosub wrins		'Write instruction to LCD

main:
gosub ShowWelcomeMsg
do						'Start DO-LOOP
setfreq m4
serin RXPin, BAUD, ("RAT"), trap	'Check if RAT is received
if trap = 1 then				'Check if received data is the number 1
	temptrap = "1"			
	gosub alarm
elseif trap = 2 then
	temptrap = "2"
	gosub alarm
else
	trap = 0			  'Reset 
end if
loop					  'End DO-LOOP

alarm:
	let b1 = 1			'Clear the LCD and move cursor to start of first line
	gosub wrins			'Send instruction to LCD
	
	for b3 = 16 to 31
	read b3, b1			'Read EEPROM address one at the time
	gosub wrchr			'Send value from EEPROM, one at the time
	next b3
	
	let b1 = 192		'192 is the value to move cursor to the start of the second line
	gosub wrins			'Send the instruction to the LCD
	
	for b3 = 32 to 37
	read b3, b1			'Read new EEPROM addresses
	gosub wrchr			'Send the values to LCD
	next b3
	
	b1 = temptrap: gosub wrchr 'Send the value of temptrap to the LCD
	pause 500			'Pause for 0.5 seconds
	b1 = 0			'Reset b1
	gosub ShowWelcomeMsg	
return


ShowWelcomeMsg:
	let b1 = 1
	gosub wrins
	
	for b3 = 0 to 15
	read b3, b1
	gosub wrchr
	next b3
	
	pause 2000
return

	
wrchr:
	let pinsb = b1 & 240	'Mask the high nibble of b1 into b2
	high b.2 			'Make sure RS is high
	pulsout b.3,1 		'Pulse the enable pin to send data
	let b2 = b1 * 16		'Put low nibble of b1 into b2
	let pinsb = b2 & 240 	'Mask the high nibble of b2
	high b.2 			'Make sure RS is high
	pulsout b.3,1 		'Pulse enable pin to send data.
	return
	
wrins:
	let pinsb = b1 & 240 	'Mask the high nibble of b1 into b2
	pulsout b.3,1 		'Pulse the enable pin to send data
	let b2 = b1 * 16 		'Put low nibble of b1 into b2
	let pinsb = b2 & 240 	'Mask the high nibble of b2
	pulsout b.3,1 		'Pulse enable pin to send data
	high b.2 			'Back to charachter mode
	return

